PROGRAM Ct_Benchmark;

{$N-}
{$M 65520,0,655360}
{$D-,Y-,L-}

USES Crt,Dos,Graph;

CONST Max =24; {Anzahl der Computer in der Vergleichstabelle}
      Space='                    ';

TYPE
  Computertyp = RECORD
    Name : STRING[30];
    Ganzzahl : Real;
    Realzahl : Real;
    Trig     : Real;
    Textscrn : Real;
    Grafscrn : Real;
    Storec   : Real;
  END;

  Computer = ARRAY [1..Max] OF Computertyp;

CONST Vergleich : Computer =(
      (Name: 'CPC 464'; Ganzzahl :7.93; Realzahl: 67.59; Trig: 117; Textscrn: 39.65; Grafscrn: 7.89; Storec: 2.38),
      (Name: 'IBM XT'; Ganzzahl :1.23; Realzahl: 39.11; Trig: 56.39; Textscrn: 64.20; Grafscrn: 6.59; Storec: 4.78),
      (Name: 'PC 8088 8 Mhz'; Ganzzahl :0.83; Realzahl: 27.30; Trig: 39.44; Textscrn: 45.97; Grafscrn: 4.66; Storec: 4.78),
      (Name: 'PC 8086 8 Mhz'; Ganzzahl :0.71; Realzahl: 15.82; Trig: 22.19; Textscrn: 29.71; Grafscrn: 1.93; Storec: 4.78),
      (Name: 'IBM AT 6 Mhz'; Ganzzahl :0.22; Realzahl: 10.22; Trig: 10.89; Textscrn: 32.84; Grafscrn: 2.47; Storec: 1.06),
      (Name: 'AT 80286 10 Mhz'; Ganzzahl :0.11; Realzahl: 6.07; Trig: 9.07; Textscrn: 13.62; Grafscrn: 0.71; Storec: 1.26),
      (Name: '80386 SX 16 Mhz'; Ganzzahl :0.10; Realzahl: 5.05; Trig: 7.24; Textscrn: 14.0; Grafscrn: 0.66; Storec: 0.9),
      (Name: '80386 SXL 16 Mhz'; Ganzzahl :0.075; Realzahl: 2.58; Trig: 2.604; Textscrn: 9.28; Grafscrn: 0.928; Storec: 2.16),
      (Name: '80386 DX 33 Mhz'; Ganzzahl :0.027; Realzahl: 1.414; Trig: 2.30; Textscrn: 9.5; Grafscrn: 0.6; Storec: 0.8),
      (Name: '80386 DX 40 Mhz'; Ganzzahl :0.0346; Realzahl: 1.26; Trig: 1.329; Textscrn: 4.01; Grafscrn: 0.467; Storec: 0.302),
      (Name: '80486 SX 33 Mhz'; Ganzzahl :0.017; Realzahl: 0.5500; Trig: 0.604; Textscrn: 3.13; Grafscrn: 0.176;
      Storec: 0.313),
      (Name: '80486 DX 33 Mhz'; Ganzzahl :0.0176; Realzahl: 0.39; Trig: 0.609; Textscrn: 3.08; Grafscrn: 0.274; Storec: 0.126),
      (Name: '80486 DX 50 Mhz'; Ganzzahl :0.0116; Realzahl: 0.368; Trig: 0.409; Textscrn: 1.93; Grafscrn: 0.137;
      Storec: 0.165),
      (Name: '80486 DX 50 Mhz VLB'; Ganzzahl :0.0126; Realzahl: 0.368; Trig: 0.401; Textscrn: 1.21; Grafscrn: 0.121;
      Storec: 0.241),
      (Name: 'AMD486 DX/4 100'; Ganzzahl :0.0060; Realzahl: 0.182; Trig: 0.208; Textscrn: 2.14; Grafscrn: 0.082;
      Storec: 0.055),
      (Name: 'AMD486 p-75 150 VLB'; Ganzzahl :0.0039; Realzahl: 0.126; Trig: 0.143; Textscrn: 2.13; Grafscrn: 0.055;
      Storec: 0.176),
      (Name: 'AMD486 p-75 133 PCI'; Ganzzahl :0.0044; Realzahl: 0.138; Trig: 0.153; Textscrn: 1.43; Grafscrn: 0.050;
      Storec: 0.067),
      (Name: 'Dell Pentium 75'; Ganzzahl :0.0083; Realzahl: 0.121; Trig: 0.130; Textscrn: 1.71; Grafscrn: 0.090;
      Storec: 0.131),
      (Name: 'Dell Pentium 90'; Ganzzahl :0.0061; Realzahl: 0.099; Trig: 0.126; Textscrn: 1.48; Grafscrn: 0.074;
      Storec: 0.028),
      (Name: 'Vobis Pentium 90'; Ganzzahl :0.0093; Realzahl: 0.148; Trig: 0.187; Textscrn: 1.76; Grafscrn: 0.105;
      Storec: 0.038),
      (Name: 'Thinkpad 365(P100)'; Ganzzahl :0.0057; Realzahl: 0.090; Trig: 0.108; Textscrn: 5.14; Grafscrn: 0.066;
      Storec: 0.035),
      (Name: 'Artist P-133'; Ganzzahl :0.0041; Realzahl: 0.066; Trig: 0.083; Textscrn: 1.26; Grafscrn: 0.05;
      Storec: 0.017),
      (Name: 'Media Markt P150'; Ganzzahl :0.0038; Realzahl: 0.06; Trig: 0.071; Textscrn: 1.49; Grafscrn: 0.044;
      Storec: 0.017),
      (Name: 'Lion K6-2-350'; Ganzzahl :0.00086; Realzahl: 0.0335; Trig: 0.0361; Textscrn: 1.43; Grafscrn: 0.033;
      Storec: 0.093)
      );

VAR I : Byte;
      Index,Len,Mips,Mflops : Real;

FUNCTION Timer : Real; {Gibt Aktuelle Zeit in Sekunden zurck. Genauigkeit : 0.01 sec}

VAR H,M,S,Ss : Word;

BEGIN
  Gettime(H,M,S,Ss);
  Timer:=H*3600+M*60+S+Ss/100;
END;

VAR Ti,Tr,Tt,Ts,Tg,Tc,Ta,Tb,A,B : Real;

PROCEDURE Intmath; {Orginal ct 10/87 n=10.000}

VAR   I,J : Integer;
      X,Y : integer;

CONST Scale = 1000; {Konstante zum Skalieren auf moderne Prozessoren}

BEGIN
  X:=0;
  Y:=3;
  WriteLn('Starte Integermathematiktest...');
  A:=Timer;
  FOR I:=1 TO 10000 DO
  FOR J:=1 TO Scale DO
  BEGIN
    X:=X+(y*y-y) DIV y;
  END;
  Ti:=Timer-A;
  Ti:=Ti/Scale;
  A:=Timer;                 {Nicht im orginal Benchmark : Errechnung der MIPS}
  FOR I:=1 TO 10000 DO      {Dazu mssen sie die Anzahl der Assembleranweisungen in der Schleife}
  FOR J:=1 TO Scale DO ;    {kennen, bei Turbo Pascal 7.0 sind es 7 Anweisungen = 0.07}
  A:=Timer-A;
  Mips:=(0.07*Scale)/(Ti-A);
  WriteLn('Finish ',X);
END;

PROCEDURE Realmath; {n=10.000}

VAR X,Y : Real;
    I,J : Integer;

CONST Scale = 100; {Konstante zum Skalieren auf moderne Prozessoren}

BEGIN
  X:=0.0;
  Y:=9.9;
  WriteLn('Starte Flieskommamathematiktest...');
  A:=Timer;
  FOR J:=1 TO Scale DO
  FOR I:=1 TO 10000 DO X:=X+(Y*Y-Y) / Y;
  Tr:=(Timer-A);
  Tr:=Tr/Scale;
  WriteLn('Finish ',X/Scale:10:4,'=89000 ?'); {Test auf Rechengenauigkeit}
  A:=Timer;                                   {Berechnung der Megaflops}
  FOR J:=1 TO Scale DO
  FOR I:=1 TO 10000 DO ;
  A:=(Timer-A);
  Mflops:=(Scale*0.04)/(Tr-A);
END;

PROCEDURE Trilog; {n=1000}


VAR X,Y : Real;
      I,J : Integer;

CONST Scale = 100; {Konstante zum Skalieren auf moderne Prozessoren}

BEGIN
  X:=0.0;
  Y:=9.9;
  WriteLn('Starte Trigonometrietest....');
  A:=Timer;
  FOR I:=1 TO 1000 DO
  FOR J:=1 TO Scale DO X:=X+Sin(ArcTan(Cos(Ln(Y))));
  Tt:=(Timer-A)/Scale;
  WriteLn('Finish ',X);
END;

PROCEDURE Textscreen;

VAR  I : Integer;

BEGIN
  WriteLn('Starte Bildschrimtest....');
  DirectVideo:=True; CheckSnow:=False;            {Nur auf Intelrechnern, seit EGA nicht mehr notwendig}
                                                  {,aber wegen der Kompabilitt noch vorhanden}
  A:=Timer;
  FOR I:=1 TO 1000 DO WriteLn('1234567890qwertzuiop',I);
  Ts:=Timer-A;
  WriteLn('Finish');
END;

PROCEDURE Graphscreen; {n=100 x 100 im Orginal}

VAR X,Y    : Integer;

BEGIN
  WriteLn('Starte Grafiktest....'); X:=VGA; Y:=VGAHi;
  InitGraph(X,Y,''); {Grafiktrieber mu installiert sein}
  IF GraphResult<>grOk THEN InitGraph(X,Y,'');
  A:=Timer;
  FOR X:=1 TO 400 DO
  FOR Y:=1 TO 250 DO PutPixel(X,Y,1);
  Tg:=(Timer-A)/10;
  CloseGraph;
  WriteLn('Finish');
END;

PROCEDURE Store; {n=1000 Im Orginal}

VAR I : Integer;
      X : STRING[60];
      T : Text;
      F : FILE;
      Drive : STRING[80];

BEGIN
  IF ParamCount>0 THEN Drive:=ParamStr(1) ELSE Drive:='';
  WriteLn('Starte Disktest...' );
  X:='123456789012345678901234567890123456789012345678901234567890';
  A:=Timer;
  Assign(T,Drive+'TEST.$$$');
  Rewrite(T);
  FOR I:=1 TO 10000 DO Write(T,X);
  Close(T);
  Tc:=(Timer-A)/10;
  Assign(F,Drive+'TEST.$$$');
  Reset(F,1);
  Len:=FileSize(F)/10240/Tc;
  WriteLn('Finish');
  Erase(T);
END;

BEGIN
  TextMode(3);
  Intmath;
  Realmath;
  Trilog;
  Textscreen;
  Graphscreen;
  Store;
  TextMode(3+Font8X8);
  WriteLn('C''T'' Benchmarktest 10/1987');
  WriteLn('(normale Version fr Real Variablen');
  WriteLn;
  CASE Test8086 OF
    0 : WriteLn('Prozessor : 8086');
    1 : WriteLn('Prozessor : 80286');
    2 : WriteLn('Prozessor : 80386 oder hher');
  END;
  CASE Test8087 OF
    0 : WriteLn('Kein Coprozessor gefunden');
    1 : WriteLn('Coprozessor : 8087');
    2 : WriteLn('Coprozessor : 80287');
    3 : WriteLn('Coprozessor : 80387 oder hher');
  END;
  WriteLn;
  WriteLn('Intmath     ',Ti:10:5,' Sec (entspricht : ',Mips:5:2,' Mips)');
  WriteLn('Realmath    ',Tr:10:5,' Sec (entspricht : ',Mflops:5:2,' MFlops)');
  WriteLn('Trilog      ',Tt:10:5,' Sec');
  WriteLn('Textscreen  ',Ts:10:5,' Sec (entspricht : ',23000/Ts:8:0,' Zeichen/sec)');
  WriteLn('Graphscreen ',Tg:10:5,' Sec (entspricht : ',10000/Tg:8:0,' Pixels/sec)');
  WriteLn('Store       ',Tc:10:5,' Sec (entspricht : ',Len:8:2,' Kbytes/sec)');
  WriteLn;
  WriteLn('Typ                  Integer Realzahl Trilog  Text   Grafik  Speichern  Index');
  WriteLn('');
  FOR I:=1 TO Max DO
  WITH Vergleich[I] DO
  BEGIN
    Index:=(Ganzzahl/Ti)+(Realzahl/Tr)+(Trig/Tt)+(Textscrn/Ts)+(Grafscrn/Tg)+(Storec/Tc);
    WriteLn(Copy(Name+Space,1,20),Ganzzahl:8:4,Realzahl:8:3,Trig:8:3,Textscrn:7:2,Grafscrn:8:3,Storec:8:3,Index/6:7:2);
  END;
END.
